QNTrainer (Apache OpenNLP Tools 1.9.5 API)
Date: 2026-06-18

opennlp.tools.ml.maxent.quasinewton

## Class QNTrainer

- java.lang.Object
- - opennlp.tools.ml.AbstractTrainer
  - - opennlp.tools.ml.AbstractEventTrainer
    - - opennlp.tools.ml.maxent.quasinewton.QNTrainer

- All Implemented Interfaces:
    EventTrainer

      public class QNTrainer
      extends AbstractEventTrainer

  Maxent model trainer using L-BFGS algorithm.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static double` | `L1COST_DEFAULT`
    `static String` | `L1COST_PARAM`
    `static double` | `L2COST_DEFAULT`
    `static String` | `L2COST_PARAM`
    `static int` | `M_DEFAULT`
    `static String` | `M_PARAM`
    `static int` | `MAX_FCT_EVAL_DEFAULT`
    `static String` | `MAX_FCT_EVAL_PARAM`
    `static String` | `MAXENT_QN_VALUE`
    `static int` | `THREADS_DEFAULT`
    `static String` | `THREADS_PARAM`

    - ### Fields inherited from class opennlp.tools.ml.AbstractEventTrainer

      `DATA_INDEXER_ONE_PASS_REAL_VALUE, DATA_INDEXER_ONE_PASS_VALUE, DATA_INDEXER_PARAM, DATA_INDEXER_TWO_PASS_VALUE`

    - ### Fields inherited from class opennlp.tools.ml.AbstractTrainer

      `ALGORITHM_PARAM, CUTOFF_DEFAULT, CUTOFF_PARAM, ITERATIONS_DEFAULT, ITERATIONS_PARAM, TRAINER_TYPE_PARAM, VERBOSE_DEFAULT, VERBOSE_PARAM`

    - ### Fields inherited from interface opennlp.tools.ml.EventTrainer

      `EVENT_VALUE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `QNTrainer()`
    `QNTrainer(boolean printMessages)`
    `QNTrainer(int m)`
    `QNTrainer(int m, boolean verbose)`
    `QNTrainer(int m, int maxFctEval, boolean printMessages)`
    `QNTrainer(TrainingParameters parameters)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `AbstractModel` | `doTrain(DataIndexer indexer)`
    `void` | `init(Map<String,String> trainParams, Map<String,String> reportMap)` Deprecated.
    `void` | `init(TrainingParameters trainingParameters, Map<String,String> reportMap)`
    `boolean` | `isSortAndMerge()`
    `boolean` | `isValid()` Deprecated.
    `QNModel` | `trainModel(int iterations, DataIndexer indexer)`
    `void` | `validate()` Check parameters.

    - ### Methods inherited from class opennlp.tools.ml.AbstractEventTrainer

      `getDataIndexer, train, train`

    - ### Methods inherited from class opennlp.tools.ml.AbstractTrainer

      `getAlgorithm, getCutoff, getIterations`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### MAXENT_QN_VALUE

          public static final String MAXENT_QN_VALUE

      See Also:
        Constant Field Values

    - #### THREADS_PARAM

          public static final String THREADS_PARAM

      See Also:
        Constant Field Values

    - #### THREADS_DEFAULT

          public static final int THREADS_DEFAULT

      See Also:
        Constant Field Values

    - #### L1COST_PARAM

          public static final String L1COST_PARAM

      See Also:
        Constant Field Values

    - #### L1COST_DEFAULT

          public static final double L1COST_DEFAULT

      See Also:
        Constant Field Values

    - #### L2COST_PARAM

          public static final String L2COST_PARAM

      See Also:
        Constant Field Values

    - #### L2COST_DEFAULT

          public static final double L2COST_DEFAULT

      See Also:
        Constant Field Values

    - #### M_PARAM

          public static final String M_PARAM

      See Also:
        Constant Field Values

    - #### M_DEFAULT

          public static final int M_DEFAULT

      See Also:
        Constant Field Values

    - #### MAX_FCT_EVAL_PARAM

          public static final String MAX_FCT_EVAL_PARAM

      See Also:
        Constant Field Values

    - #### MAX_FCT_EVAL_DEFAULT

          public static final int MAX_FCT_EVAL_DEFAULT

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### QNTrainer

          public QNTrainer(TrainingParameters parameters)

    - #### QNTrainer

          public QNTrainer(boolean printMessages)

    - #### QNTrainer

          public QNTrainer(int m)

    - #### QNTrainer

          public QNTrainer(int m,
                           boolean verbose)

    - #### QNTrainer

          public QNTrainer(int m,
                           int maxFctEval,
                           boolean printMessages)

    - #### QNTrainer

          public QNTrainer()

  - ### Method Detail

    - #### init

          public void init(TrainingParameters trainingParameters,
                           Map<String,String> reportMap)

      Specified by:
        `init` in interface `EventTrainer`
      Overrides:
        `init` in class `AbstractTrainer`

    - #### init

          @Deprecated
          public void init(Map<String,String> trainParams,
                                       Map<String,String> reportMap)

      Deprecated.
      Specified by:
        `init` in interface `EventTrainer`
      Overrides:
        `init` in class `AbstractTrainer`

    - #### validate

          public void validate()

      Description copied from class: `AbstractTrainer`
      Check parameters. If subclass overrides this, it should call super.validate();
      Overrides:
        `validate` in class `AbstractEventTrainer`

    - #### isValid

          @Deprecated
          public boolean isValid()

      Deprecated.
      Overrides:
        `isValid` in class `AbstractEventTrainer`
      Returns:

    - #### isSortAndMerge

          public boolean isSortAndMerge()

      Specified by:
        `isSortAndMerge` in class `AbstractEventTrainer`

    - #### doTrain

          public AbstractModel doTrain(DataIndexer indexer)
                                throws IOException

      Specified by:
        `doTrain` in class `AbstractEventTrainer`
      Throws:
        `IOException`

    - #### trainModel

          public QNModel trainModel(int iterations,
                                    DataIndexer indexer)

Copyright © 2026 The Apache Software Foundation. All rights reserved.